; #########################################################################
;
;This is my include file for masm programming.
;
; #########################################################################

WM_CAP_START				equ WM_USER
WM_CAP_GET_CAPSTREAMPTR 		equ WM_CAP_START + 1
WM_CAP_SET_CALLBACK_ERROR 		equ WM_CAP_START + 2
WM_CAP_SET_CALLBACK_STATUS 		equ WM_CAP_START + 3
WM_CAP_SET_CALLBACK_YIELD 		equ WM_CAP_START + 4
WM_CAP_SET_CALLBACK_FRAME 		equ WM_CAP_START + 5
WM_CAP_SET_CALLBACK_VIDEOSTREAM 	equ WM_CAP_START + 6
WM_CAP_SET_CALLBACK_WAVESTREAM 		equ WM_CAP_START + 7
WM_CAP_GET_USER_DATA 			equ WM_CAP_START + 8
WM_CAP_SET_USER_DATA 			equ WM_CAP_START + 9
WM_CAP_DRIVER_CONNECT 			equ WM_CAP_START + 10
WM_CAP_DRIVER_DISCONNECT 		equ WM_CAP_START + 11
WM_CAP_DRIVER_GET_NAME 			equ WM_CAP_START + 12
WM_CAP_DRIVER_GET_VERSION 		equ WM_CAP_START + 13
WM_CAP_DRIVER_GET_CAPS 			equ WM_CAP_START + 14
WM_CAP_FILE_SET_CAPTURE_FILE 		equ WM_CAP_START + 20
WM_CAP_FILE_GET_CAPTURE_FILE 		equ WM_CAP_START + 21
WM_CAP_FILE_ALLOCATE 			equ WM_CAP_START + 22
WM_CAP_FILE_SAVEAS 			equ WM_CAP_START + 23
WM_CAP_FILE_SET_INFOCHUNK 		equ WM_CAP_START + 24
WM_CAP_FILE_SAVEDIB 			equ WM_CAP_START + 25
WM_CAP_EDIT_COPY 			equ WM_CAP_START + 30
WM_CAP_SET_AUDIOFORMAT 			equ WM_CAP_START + 35
WM_CAP_GET_AUDIOFORMAT 			equ WM_CAP_START + 36
WM_CAP_DLG_VIDEOFORMAT 			equ WM_CAP_START + 41
WM_CAP_DLG_VIDEOSOURCE 			equ WM_CAP_START + 42
WM_CAP_DLG_VIDEODISPLAY 		equ WM_CAP_START + 43
WM_CAP_GET_VIDEOFORMAT 			equ WM_CAP_START + 44
WM_CAP_SET_VIDEOFORMAT 			equ WM_CAP_START + 45
WM_CAP_DLG_VIDEOCOMPRESSION 		equ WM_CAP_START + 46
WM_CAP_SET_PREVIEW 			equ WM_CAP_START + 50
WM_CAP_SET_OVERLAY 			equ WM_CAP_START + 51
WM_CAP_SET_PREVIEWRATE 			equ WM_CAP_START + 52
WM_CAP_SET_SCALE 			equ WM_CAP_START + 53
WM_CAP_GET_STATUS 			equ WM_CAP_START + 54
WM_CAP_SET_SCROLL 			equ WM_CAP_START + 55
WM_CAP_GRAB_FRAME 			equ WM_CAP_START + 60
WM_CAP_GRAB_FRAME_NOSTOP 		equ WM_CAP_START + 61
WM_CAP_SEQUENCE 			equ WM_CAP_START + 62
WM_CAP_SEQUENCE_NOFILE 			equ WM_CAP_START + 63
WM_CAP_SET_SEQUENCE_SETUP 		equ WM_CAP_START + 64
WM_CAP_GET_SEQUENCE_SETUP 		equ WM_CAP_START + 65
WM_CAP_SET_MCI_DEVICE 			equ WM_CAP_START + 66
WM_CAP_GET_MCI_DEVICE 			equ WM_CAP_START + 67
WM_CAP_STOP 				equ WM_CAP_START + 68
WM_CAP_ABORT 				equ WM_CAP_START + 69
WM_CAP_SINGLE_FRAME_OPEN 		equ WM_CAP_START + 70
WM_CAP_SINGLE_FRAME_CLOSE 		equ WM_CAP_START + 71
WM_CAP_SINGLE_FRAME 			equ WM_CAP_START + 72
WM_CAP_PAL_OPEN 			equ WM_CAP_START + 80
WM_CAP_PAL_SAVE 			equ WM_CAP_START + 81
WM_CAP_PAL_PASTE 			equ WM_CAP_START + 82
WM_CAP_PAL_AUTOCREATE 			equ WM_CAP_START + 83
WM_CAP_PAL_MANUALCREATE 		equ WM_CAP_START + 84

CAPDRIVERCAPS STRUCT
    wDeviceIndex 			DWORD		? 
    fHasOverlay 			DWORD		?
    fHasDlgVideoSource			DWORD		?  
    fHasDlgVideoFormat			DWORD		?
    fHasDlgVideoDisplay			DWORD		?
    fCaptureInitialized			DWORD		?
    fDriverSuppliesPalettes		DWORD		?
    hVideoIn				DWORD		?
    hVideoOut				DWORD		?
    hVideoExtIn				DWORD		?
    hVideoExtOut			DWORD		?
CAPDRIVERCAPS ENDS

VIDEOHDR STRUCT
    lpData				DWORD		?
    dwBufferLength			DWORD		?
    dwBytesUsed				DWORD		?
    dwTimeCaptured			DWORD		?
    dwUser				DWORD		?
    dwFlags				DWORD		?
    dwReserved1				DWORD		?
    dwReserved2				DWORD		?
    dwReserved3				DWORD		?
VIDEOHDR ENDS

CAPTUREPARMS STRUCT
    dwRequestMicroSecPerFrame		DWORD		?	;// // Requested capture rate
    fMakeUserHitOKToCapture 		DWORD		?	;// // Show "Hit OK to cap" dlg?
    wPercentDropForError 		DWORD		?	;// // Give error msg if > (10%)
    fYield 				DWORD		?	;// // Capture via background task?
    dwIndexSize 			DWORD		?	;// // Max index size in frames (32K)
    wChunkGranularity 			DWORD		?	;// // Junk chunk granularity (2K)
    fUsingDOSMemory 			DWORD		?	;// // Use DOS buffers?
    wNumVideoRequested 			DWORD		?	;// // # video buffers, If 0, autocalc
    fCaptureAudio 			DWORD		?	;// // Capture audio?
    wNumAudioRequested 			DWORD		?	;// // # audio buffers, If 0, autocalc
    vKeyAbort 				DWORD		?	;// // Virtual key causing abort
    fAbortLeftMouse 			DWORD		?	;// // Abort on left mouse?
    fAbortRightMouse 			DWORD		?	;// // Abort on right mouse?
    fLimitEnabled 			DWORD		?	;// // Use wTimeLimit?
    wTimeLimit 				DWORD		?	;// // Seconds to capture
    fMCIControl 			DWORD		?	;// // Use MCI video source?
    fStepMCIDevice 			DWORD		?	;// // Step MCI device?
    dwMCIStartTime 			DWORD		?	;// // Time to start in MS
    dwMCIStopTime 			DWORD		?	;// // Time to stop in MS
    fStepCaptureAt2x 			DWORD		?	;// // Perform spatial averaging 2x
    wStepCaptureAverageFrames 		DWORD		?	;// // Temporal average n Frames
    dwAudioBufferSize 			DWORD		?	;// // Size of audio bufs (0 = default)
    fDisableWriteCache 			DWORD		?	;// // Attempt to disable write cache
CAPTUREPARMS ENDS

VFWPOINT STRUCT
	x DWORD		? 	
	y DWORD		?
VFWPOINT ENDS

CAPSTATUS STRUCT
    uiImageWidth 			DWORD	?	;'// Width of the image
    uiImageHeight			DWORD	?	;'// Height of the image
    fLiveWindow				DWORD	?	;'// Now Previewing video?
    fOverlayWindow			DWORD	?	;'// Now Overlaying video?
    vfwScale				DWORD	?	;'// Scale image to client?
    ptScroll				VFWPOINT <>	;'// Scroll position
    fUsingDefaultPalette		DWORD	?	;'// Using default driver palette?
    fAudioHardware			DWORD	?	;'// Audio hardware present?
    fCapFileExists			DWORD	?	;'// Does capture file exist?
    dwCurrentVideoFrame			DWORD	?	;'// # of video frames cap'td
    dwCurrentVideoFramesDropped		DWORD	?	;'// # of video frames dropped
    dwCurrentWaveSamples		DWORD	?	;'// # of wave samples cap'td
    dwCurrentTimeElapsedMS		DWORD	?	;'// Elapsed capture duration
    hPalCurrent				DWORD	?	;'// Current palette in use
    fCapturingNow			DWORD	?	;'// Capture in progress?
    dwReturn				DWORD	?	;'// Error value after any operation
    wNumVideoAllocated			DWORD	?	;'// Actual number of video buffers
    wNumAudioAllocated			DWORD	?	;'// Actual number of audio buffers
CAPSTATUS ENDS

DTM_SETFORMAT		equ 001005h 
DTM_GETSYSTEMTIME	equ 001001h 
DTM_SETSYSTEMTIME	equ 001002h 
SB_SETICON		equ 1039

DLLVERSIONINFO STRUCT 
    cbSize            dd    ? 
    dwMajorVersion    dd    ? 
    dwMinorVersion    dd    ? 
    dwBuildNumber     dd    ? 
    dwPlatformID      dd    ? 
DLLVERSIONINFO    ENDS 

; #########################################################################
    szText  MACRO Name, Text:VARARG
        LOCAL   lbl
        jmp     lbl
        Name    db Text,0
        lbl:
    ENDM
    
    m2m MACRO M1, M2
        push    M2
        pop     M1
    ENDM
    
    return MACRO arg
        mov     eax, arg
        ret
    ENDM
    
    RGB MACRO red,green,blue
        xor     eax,eax
        mov     ah,blue
        shl     eax,8
        mov     ah,green
        mov     al,red
    ENDM
    
; #########################################################################

    TBextraData MACRO
        mov     tbb.fsState,   TBSTATE_ENABLED
        mov     tbb.dwData,    0
        mov     tbb.iString,   0
    ENDM

    TBbutton MACRO bID, cID, Stl
        mov     tbb.iBitmap,   bID  ;; button  ID number
        mov     tbb.idCommand, cID  ;; command ID number
        mov     tbb.fsStyle,   Stl  ;; TBSTYLE_BUTTON
        invoke  SendMessage,hToolBar,TB_ADDBUTTONS,1,ADDR tbb
    ENDM

    TBblank MACRO
        mov     tbb.iBitmap,   0
        mov     tbb.idCommand, 0
        mov     tbb.fsStyle,   TBSTYLE_SEP
        invoke  SendMessage,hToolBar,TB_ADDBUTTONS,1,ADDR tbb
    ENDM

    Create_Tool_Bar MACRO Wd, Ht
        szText tbClass,"ToolbarWindow32"
        invoke  CreateWindowEx,0,
                ADDR tbClass,
                ADDR szDisplayName,
                WS_CHILD or WS_VISIBLE or TBSTYLE_TOOLTIPS or TBSTYLE_FLAT,    ;or TTS_BALLOON
                0,0,500,40,
                hWin,NULL,
                hInstance,NULL
        mov     hToolBar,   eax
        invoke  SendMessage,hToolBar,TB_BUTTONSTRUCTSIZE,sizeof TBBUTTON,0
        

; #########################################################################
; Put width & height of bitmap into DWORD
; #########################################################################
        mov     ecx,        Wd  ;; loword = bitmap Width
        mov     eax,        Ht  ;; hiword = bitmap Height
        shl     eax,        16
        mov     ax,         cx
        mov     bSize,      eax
        invoke  SendMessage,hToolBar,TB_SETBITMAPSIZE,0,bSize
        invoke  SetBmpColor,hTbBmp
        mov     hTbBmp,     eax
        mov     tbab.hInst, 0
        m2m     tbab.nID,   hTbBmp
        invoke  SendMessage,hToolBar,TB_ADDBITMAP,12,ADDR tbab
        invoke  SendMessage,hToolBar,TB_SETBUTTONSIZE,0,bSize
    ENDM
      
